<xsl:transform
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 version="1.0"
>

<xsl:template match="/">
  <html><body>
    <xsl:variable name="all-books" select="//book"/>
    <xsl:for-each select="$all-books">
      <h1><xsl:value-of select="title"/></h1>
      <p><i>by </i><xsl:value-of select="author"/> 
         <xsl:if test="count(author)!=1"> and others</xsl:if>
      </p>
      <xsl:variable name="others"
        select="$all-books[./@category=current()/@category and
                             generate-id(.)!=generate-id(current())]"/>
        <xsl:if test="$others">
          <p>Other books in this category:</p><ul>
          <xsl:for-each select="$others">
             <li><xsl:value-of select="title"/></li>
          </xsl:for-each>
          </ul>
        </xsl:if>
    </xsl:for-each>
  </body></html>
</xsl:template>

</xsl:transform>

